/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: SuperSubScriptEquation.h,v 1.4 2004/02/16 12:52:13 yoshi Exp $ */ 
#ifndef SuperSubScriptEquation_h
#define SuperSubScriptEquation_h

#include "ChildContainerEquation.h"
#include "EquationUtil.h"

class SuperSubScriptEquation : public ChildContainerEquation
{
private:
	typedef ChildContainerEquation Super;
private:
	Equation	*m_super;
	Equation	*m_sub;
	Equation	*m_content;

public:
	SuperSubScriptEquation()
		: Super(), m_super(0), m_sub(0), m_content(0) {;}

	void	super(Equation *p) { m_super = p; push(p);}
	void	sub(Equation *p) { m_sub = p; push(p);}
	void	content(Equation *p) { m_content = p; push(p);}

	Equation *	super() { return m_super; }
	Equation *	sub() { return m_sub; }
	Equation *	content() { return m_content; }
};

#endif  // SuperSubScriptEquation_h
