/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: TextLineBufferContainerIterator.cpp,v 1.3 2003/10/02 10:07:12 yoshi Exp $ */ 
#include "TextLineBufferContainerIterator.h"
#include "TextLineBufferContainer.h"
#include <assert.h>
#include <string.h>

bool TextLineBufferContainerIterator::hasMoreElements()
{
	m_curr++;
	return (m_curr < m_cntr.size())? true: false; 
}

char *TextLineBufferContainerIterator::element()
{
	assert(m_curr < m_cntr.size());
	return m_cntr.element(m_curr);
}

char *TextLineBufferContainerIterator::releaseElement()
{
	char *str = element();
	int len = strlen(str);
	char *dup = new char [len+1];
	strcpy(dup, str);
	return dup;
}

char *TextLineBufferContainerIterator::element(int)
{
	assert(0);
	return 0;
}

int  TextLineBufferContainerIterator::line()
{
	return m_curr+1;
}


#ifdef LINEBUFFERCNTR_TEST
#include "TextFileLineReadIterator.h"
#include <stdio.h>
int main(int argc, char **argv)
{
	if (argc != 2) { printf("%s filename\n", argv[0]); return 1; }

	char *fname = argv[1];
	TextLineBufferContainer cntr;
	TextFileLineReadIterator fitr(fname);
	while (fitr.hasMoreElements()) {
		char *line = fitr.element();
		printf(line);
		cntr.push(line);
	}

	TextLineBufferContainerIterator itr(cntr);
	while (itr.hasMoreElements()) {
		char *p = itr.element();
		printf("%s\n", p);
	}
}

#endif
