/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: TextLineReadIteratorImpl.h,v 1.5 2003/10/02 10:07:30 yoshi Exp $ */ 
#ifndef TextLineReadIteratorImpl_h
#define TextLineReadIteratorImpl_h

#include <stdio.h>
#include "TextLineReadIterator.h"

class CharReplacer;

class TextLineReadIteratorImpl : public TextLineReadIterator
{
private:
	char	*m_buf;
	int	m_bufsize;
	CharReplacer	*m_replacer;
	int	m_line;
	
protected:
	FILE	*m_fp;

private:
	char 	*alloc(int size);
	char	*replace();
	void	free();
	void	goToStart();
	bool	next();
public:
	TextLineReadIteratorImpl();
	virtual ~TextLineReadIteratorImpl();

	FILE *file() { return m_fp; }

	void	set(CharReplacer *);
	bool	hasMoreElements() { return next(); }
	char	*element();
	char	*element(int);
	char	*releaseElement();
	int	line() { return m_line; }
};
 


#endif  // TextLineReadIteratorImpl_h
