/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: Math2DIniFileWriter.h,v 1.1 2003/09/16 09:10:15 yoshi Exp $ */ 
#ifndef Math2DIniFileWriter_h
#define Math2DIniFileWriter_h

#pragma warning(disable:4786)
#include <string>

class Math2DIniFileWriter
{
private:
	std::string	m_fname;
private:
	bool	writeString(const char *section, const char *key, const char *value);
	bool	writeFont(const char *key, const char *font);
	bool	writeColor(const char *key, UINT);
public:
	Math2DIniFileWriter(const char *fname);

	bool	stringNormalFacename(const char *);
	bool	bigSymbolFacename(const char *);
	bool	operatorFacename(const char *);
	bool	functionFacename(const char *);
	bool	paramFacename(const char *);
	bool	bracketFacename(const char *);
	bool	arrowFacename(const char *);
	bool	enumFacename(const char *);

	bool	normalColor(UINT);
	bool	hilightColor(UINT);
	bool	linkColor(UINT);
};


#endif // Math2DIniFileWriter_h
 
