/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: ProductEquationParser.h,v 1.2 2002/09/02 06:17:07 yoshi Exp $ */ 
#ifndef ProductEquationParser_h
#define ProductEquationParser_h

#include "CharSpliterEquationParser.h"
#include "ProductEquation.h"

class ProductEquationOperator
{
public:
	void	upper(ProductEquation *prod, Equation *eq) { prod->super(eq); }
	void	lower(ProductEquation *prod, Equation *eq) { prod->sub(eq); }
	void	right(ProductEquation *prod, Equation *eq) { prod->content(eq); }
};

const char PRODUCT_SPLIT_CHAR = '*';

class ProductEquationParser
	: public CharSpliterEquationParser<ProductEquation, ProductEquationOperator, PRODUCT_SPLIT_CHAR>
{
private:
	typedef CharSpliterEquationParser<ProductEquation, ProductEquationOperator, PRODUCT_SPLIT_CHAR> Super;
private:
	int parseType() { return PARSE_ALL; }
public:
	static bool	match(char *str, int head)
	{
		return Super::match(str, head);
	}
};

#endif  // ProductEquationParser_h
