#
# $Id: bsext.rb,v 1.3 2004/02/20 04:13:29 yoshi Exp $
#

# ====== bsext.rb ==============
#
# // -- backslash start --
# 
# ܂
#
# // -- backslash greek start --
#
# 
#
# // -- backslash start --
#
# ܂ł̃_uNH[e[Vň͂܂ꂽ𔲂oA
# ̕𓾂֐쐬B
#

#
# o͊֐Q
#

def printHeader(funcname)
  print <<"DECLARE_FUNC"
char **#{funcname}(int *n)
{
   static char *strs[] = {
DECLARE_FUNC
end

def printFooter
  print <<END_FUNC
};
   *n = sizeof(strs)/sizeof(strs[0]);
   return strs;
}
END_FUNC
end

def printToken(s)
  print "\t\"\\\\", s, "\",\n"
end

def printEmpty()
  print "\t0,\n"
end

#
# Block NX
# 
class BackSlashBlock

  def initialize
    @cnt = 0
  end
  
  def echo(s)
    printToken s
    @cnt = @cnt+1
  end
  
  def flush
    if @cnt > 0 then
      printEmpty
      @cnt = 0
    end
  end

end

class GreekBlock
  def initialize
    @ups = Array.new
  end
  
  def echo(s)
    printToken s
    @ups.push(s.capitalize)
  end
  
  def flush
    printEmpty
    @ups.each do |s| 
      printToken s
    end
    printEmpty
  end
  
end

class OutofBlock
  def echo(s)
  end
  def flush
  end
end

#
# C
#
funcname = ARGV.shift
printHeader(funcname)
block = OutofBlock.new

while gets

  if /\/\/[-\s]+backslash start(greek)/
    block = GreekBlock.new
  elsif /\/\/[-\s]+backslash start/
    block = BackSlashBlock.new
  elsif /\/\/[-\s]+backslash end/
    block.flush
    block = OutofBlock.new
  else

    block.echo ($1) if /"([^"]+)"/
    block.flush if /^$/

  end
  
end

printFooter
