/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: LineChecker.h,v 1.1 2001/10/18 06:06:35 yoshi Exp $ */ 
#ifndef LineChecker_h
#define LineChecker_h

class LineChecker
{
public:
	enum Type {
		NORMAL_LINE = 0,  	// ʂ̋Lq
		IGNORE,	          	// s
		SPLIT_UNIT, 		// e[űE
		SPLIT_BLOCK, 		// ubN̋E
		CHANGE_LINE,};          // [Uɂsw

	class NormalLine        
	{
	public:
		Type	type;	// NORMAL_LINE
		int	start;	// Lq̎n܂ʒu
	};

	class Ignore { Type type;};

	class ChangeLine
	{
	public:
		Type	type;   // CHANGE_LINE
		int	end;	// Lq̏Iʒu
		int	nextStart; // ̍s̎n܂ʒu
		NormalLine normalLine; // ŏ̍s̑
	};

	class SplitUnit
	{
	public:
		Type type;
	};

	class SplitBlock
	{
	public:
		Type type;
	};

	class Result{
	public:
		Type		type;
		NormalLine	nornalLine;
		ChangeLine	changeLine;
	} m_result;

public:
	Type 	check(char *line);
	Type	operator()(char *line) { return check(line); }
	Result	&result() { return m_result; }
};

#endif  // LineChecker_h
