/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: StringBlockUnitCoordinator.h,v 1.1 2001/10/18 06:06:37 yoshi Exp $ */ 
#ifndef StringBlockUnitCoordinator_h
#define StringBlockUnitCoordinator_h

#include "IndexConverter.h"

class StringBlockUnit;

class StringBlockUnitCoordinator : public YIndexConverter
{
private:
	enum  { BASELINE_NOT_SET = -1, };
private:
	int	m_blockWidth;
	// ubÑx[XC[ւ̃ItZbg
	int	m_blockUpperBoundOffset;
	// ubÑx[XC牺[ւ̃ItZbg
	int	m_blockLowerBoundOffset;
	int	m_blockBaseline;	// ubÑx[XC
	int	m_cnt;

private:
	int	blockUpperBoundOffset() { return m_blockUpperBoundOffset; }
	void	blockUpperBoundOffset(int n) { m_blockUpperBoundOffset = n; }
	int	blockLowerBoundOffset() { return m_blockLowerBoundOffset; }
	void	blockLowerBoundOffset(int n) { m_blockLowerBoundOffset = n; }
	
public:
	StringBlockUnitCoordinator();
	void	set(StringBlockUnit *);

	int	blockWidth();
	int	blockHeight();
	int	blockBaseline() { return m_blockBaseline; }
	
	int 	blockIndex(StringBlockUnit *, int unitIndex); // index block -> unit
	int	unitIndex(StringBlockUnit *, int blockIndex); // index unit -> block
	int	to(StringBlockUnit *p, int i);
};

#endif  // StringBlockUnitCoordinator_h
