/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: PHTexExec.h,v 1.9 2003/09/17 11:42:31 yoshi Exp $ */ 
#ifndef PHTexExec_h
#define PHTexExec_h

#include "EquationDictionary.h"
#include "ErrorTextWriter.h"
#include <string.h>

class PHTexParamBase;
class Math2DTexDrawer;
class DrawContext;

class PHTexExec
{
private:
	PHTexParamBase	&m_param;
	EquationDictionary	m_dictionary;
	DrawContext		*m_context;
	ErrorTextWriter	*	m_errWriter;

private:
	void	free_();

private:
	DrawContext &	context();
	Math2DTexDrawer *createDrawer();
	void		startDraw(DrawContext &c);
	void		endDraw(DrawContext &c);

public:
	PHTexExec(PHTexParamBase &c);
	~PHTexExec() { free_(); }

	void	set(ErrorTextWriter *p) { m_errWriter = p; }
	bool	draw();
};


#endif // PHTexExec_h
