/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: List.h,v 1.3 2002/01/18 06:49:14 yoshi Exp $ */ 
#ifndef List_h
#define List_h


template<class T>
class List
{
public:
	class Node
	{
	public:
		T	object;
		Node 	*prev, *next;
	public:
		Node() : object(0), prev(0), next(0){;}
	};

private:
	Node *		m_first;
	Node *		m_end;

private:
	void	free()
	{
		if (!m_first) { return; }
		Node *p, *next;
		for (p=m_first; p; p=next) {
			next = p->next; delete p;
		}
		m_first = m_end = 0;
	}
public:
	List() : m_first(0), m_end(0) {;}
	virtual ~List() { free(); }

	void pushBack(T &t)
	{
		Node *node = new Node;
		node->object = t;

		if (!m_first) { m_first = m_end = node; }
		else {
			m_end->next = node; node->prev = m_end; m_end = node;
		}
	}

	int		size()
	{
		int cnt = 0;
		Node *p;
		for (p=first(); p; p=next(p)) { cnt++; }
		return cnt;
	}
	
	Node*		first() { return (m_first)? m_first: 0; }
	T &		object(Node *node) { return node->object; }
	Node*		prev(Node *node) { return node->prev; }
	Node*		next(Node *node) { return node->next; }
	void		clear() { free(); }
};

template<class T>
class ListIterator
{
private:
	List<T> *	m_list;
	List<T>::Node	*	m_curr;
	T		m_null;
public:
	ListIterator() : m_list(0), m_curr(0) {m_null = 0;}
	ListIterator(List<T> *p) : m_list(p), m_curr(0) {m_null = 0;}

	void	set(List<T> *list) { m_list = list; }

	bool	hasMoreElements()
	{
		if (!m_list) { return false; }
		if (!m_curr) { m_curr = m_list->first(); }
		else { m_curr = m_list->next(m_curr); }
		return (m_curr)? true: false;
	}

	bool	first()
	{
		if (!m_list) { return false; }
		return (m_curr = m_list->first())? true: false;
	}

	bool	next()
	{
		if (!m_list || !m_curr) { return false; }
		m_curr = m_list->next(m_curr);
		return (m_curr)? true: false;
	}

	bool	prev()
	{
		if (!m_list || !m_curr) { return false; }
		m_curr = m_list->prev(m_curr);
		return (m_curr)? true: false;
	}

	T& 	element() { return (m_curr)? m_list->object(m_curr): m_null; }
};

#endif  // List_h
