// FontSelectDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "PHConfig.h"
#include "FontSelectDialog.h"

#include <assert.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// FontSelectDialog _CAO


FontSelectDialog::FontSelectDialog(CWnd* pParent /*=NULL*/)
	: CDialog(FontSelectDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(FontSelectDialog)
	//}}AFX_DATA_INIT
}


void FontSelectDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(FontSelectDialog)
	DDX_Control(pDX, IDC_COMBO_ELSE, m_else);
	DDX_Control(pDX, IDC_LIST_FONTS, m_fonts);
	DDX_Control(pDX, IDC_COMBO_OPERATOR, m_operator);
	DDX_Control(pDX, IDC_COMBO_FUNCTION, m_function);
	DDX_Control(pDX, IDC_COMBO_ENUM, m_enum);
	DDX_Control(pDX, IDC_COMBO_BRACKET, m_bracket);
	DDX_Control(pDX, IDC_COMBO_BIG_SYMBOL, m_bigSymbol);
	DDX_Control(pDX, IDC_COMBO_PARAM, m_param);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(FontSelectDialog, CDialog)
	//{{AFX_MSG_MAP(FontSelectDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// FontSelectDialog bZ[W nh

#include "FontListProvider.h"
	
static void copy(CListBox &from, CComboBox &to)
{
	CString buf;
	const int n = from.GetCount();
	for (int i=0; i<n; i++) {
		from.GetText(i, buf);
		to.AddString(buf);
	}
}

#define ARRAY_SIZE(ARY) (sizeof(ARY)/sizeof(ARY[0]))

void FontSelectDialog::copyFont()
{
	const int n = ARRAY_SIZE(m_combos);
	for (int i=0; i<n; i++){
		CComboBox *p = m_combos[i];
		copy(m_fonts, *p);
	}
}


void FontSelectDialog::init()
{
	m_combos[BIG_SYMBOL] = &m_bigSymbol;
	m_combos[OPERATOR] = &m_operator;
	m_combos[FUNCTION] = &m_function;
	m_combos[PARAM] = &m_param;
	m_combos[BRACKET] = &m_bracket;
	m_combos[ENUM] = &m_enum;

	m_combos[STRING_NORMAL] = &m_else;
	m_combos[ARROW] = &m_else;

#ifdef _DEBUG
	const int n = ARRAY_SIZE(m_combos);
	for (int i=0; i<n; i++) {
		assert(m_combos);
	}
#endif

}

void FontSelectDialog::set(Type t, const char *font)
{
	const int ALL = -1;
	m_combos[t]->SelectString(ALL, font);
}

BOOL FontSelectDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	init();
	
	FontListProvider provide(*this, m_fonts);
	provide();

	copyFont();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


const char *FontSelectDialog::get(Type t)
{
	static char buf[1024];
	m_combos[t]->GetWindowText(buf, sizeof(buf));
	return buf;
}
