// PHConfigDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "PHConfig.h"
#include "PHConfigDlg.h"

#include <assert.h>

#include "PHControlProperty.h"
#include "Math2DIniFileReader.h"
#include "Math2DIniFileWriter.h"
#include "FileUtil.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPHConfigDlg _CAO

CPHConfigDlg::CPHConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPHConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPHConfigDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDI_PAPERHOUSE);

	m_inifile = PHControlProperty::inifile();
	m_tmpfile = m_inifile + ".bak";
	m_defaultfile = m_inifile + ".default";
	if (!FileUtil::fileExist(m_inifile)) {
		FileUtil::copy(m_defaultfile, m_inifile);
	}

}

void CPHConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPHConfigDlg)
	DDX_Control(pDX, IDC_COMBO_SAMPLE_LIST, m_samples);
	DDX_Control(pDX, IDC_TAB, m_tab);
	DDX_Control(pDX, IDC_PHMATH2DCTRL1, m_eq);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPHConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CPHConfigDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, OnSelchangeTab)
	ON_NOTIFY(TCN_SELCHANGING, IDC_TAB, OnSelchangingTab)
	ON_BN_CLICKED(IDC_BUTTON_REDRAW, OnButtonRedraw)
	ON_BN_CLICKED(IDC_BUTTON_DEFAULT, OnButtonDefault)
	ON_CBN_SELCHANGE(IDC_COMBO_SAMPLE_LIST, OnSelchangeComboSampleList)
	ON_BN_CLICKED(IDC_BUTTON_SET_DEFAULT, OnButtonSetDefault)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_FILE, OnButtonSelectFile)
	ON_BN_CLICKED(IDC_BUTTON_SAVE, OnButtonSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPHConfigDlg bZ[W nh


void CPHConfigDlg::initTab()
{
	TC_ITEM item;

	item.mask = TCIF_TEXT;
	item.pszText = "tHg";
	m_tab.InsertItem(0, &item);

	item.pszText = "F";
	m_tab.InsertItem(1, &item);

	item.pszText = "o[W";
	m_tab.InsertItem(2, &item);

	m_fontTab.Create(IDD_FONT_SELECT_DIALOG, &m_tab);
	m_colorTab.Create(IDD_COLOR_SELECT_DIALOG, &m_tab);
	m_infoTab.Create(IDD_PH_INFO_DIALOG, &m_tab);

	RECT rect;
	m_tab.GetWindowRect(&rect);
	const int x0 = 5;
	const int y0 = 30;
	const int w = rect.right - 25;
	const int h = rect.bottom - 70;

	m_fontTab.SetWindowPos(&wndTop, x0, y0, w, h, SWP_NOSIZE|SWP_SHOWWINDOW);
	m_colorTab.SetWindowPos(&wndTop, x0, y0, w, h, SWP_NOSIZE|SWP_HIDEWINDOW);
	m_infoTab.SetWindowPos(&wndTop, x0, y0, w, h, SWP_NOSIZE|SWP_HIDEWINDOW);
}

#define LOAD_FONT(GET, TYPE) \
{ char *p = read.##GET##(); \
 if (p) { m_fontTab.set(FontSelectDialog::TYPE, p); } }

#define LOAD_COLOR(GET, SET) \
{ UINT C = read.##GET##(); m_colorTab.##SET##(C);}

bool CPHConfigDlg::loadConfig()
{
	if (m_inifile.GetLength() <= 0) { return false; }
	Math2DIniFileReader read(m_inifile);

	LOAD_FONT(stringNormalFacename, STRING_NORMAL);
	LOAD_FONT(bigSymbolFacename, BIG_SYMBOL);
	LOAD_FONT(operatorFacename, OPERATOR);
	LOAD_FONT(functionFacename, FUNCTION);
	LOAD_FONT(paramFacename, PARAM);
	LOAD_FONT(bracketFacename, BRACKET);
	LOAD_FONT(arrowFacename, ARROW);
	LOAD_FONT(enumFacename, ENUM);

	LOAD_COLOR(normalColor, setNormalColor);
	LOAD_COLOR(hilightColor, setHilightColor);
	LOAD_COLOR(linkColor, setLinkColor);

	return true;
}

BOOL CPHConfigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(AfxGetApp()->LoadIcon(IDI_PAPERHOUSE), FALSE);

	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	initTab();
	loadConfig();
	showSampleList();
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CPHConfigDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CPHConfigDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CPHConfigDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPHConfigDlg::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int n = m_tab.GetCurSel();
	CWnd	*wnd = 0;
	switch(n) {
	case 0:
		wnd = &m_fontTab; break;
	case 1:
		wnd = &m_colorTab; break;
	case 2:
		wnd = &m_infoTab; break;
	default:
		assert(0); break;
	}
	wnd->ShowWindow(SW_SHOW);
	
	*pResult = 0;
}

void CPHConfigDlg::OnSelchangingTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	int n = m_tab.GetCurSel();
	CWnd	*wnd = 0;
	switch(n) {
	case 0:
		wnd = &m_fontTab; break;
	case 1:
		wnd = &m_colorTab; break;
	case 2:
		wnd = &m_infoTab; break;
	default:
		assert(0); break;
	}
	wnd->ShowWindow(SW_HIDE);
	
	*pResult = 0;
}

#define WRITE_FONT(SET, TYPE) write.##SET##(m_fontTab.get(FontSelectDialog::##TYPE##))
#define WRITE_COLOR(SET, GET) write.##SET##(m_colorTab.##GET##())

bool CPHConfigDlg::writeConfig(const char *fname)
{
	Math2DIniFileWriter	write(fname);
	WRITE_FONT(stringNormalFacename, STRING_NORMAL);
	WRITE_FONT(bigSymbolFacename, BIG_SYMBOL);
	WRITE_FONT(operatorFacename, OPERATOR);
	WRITE_FONT(functionFacename, FUNCTION);
	WRITE_FONT(paramFacename, PARAM);
	WRITE_FONT(bracketFacename, BRACKET);
	WRITE_FONT(arrowFacename, ARROW);
	WRITE_FONT(enumFacename, ENUM);

	WRITE_COLOR(normalColor, normalColor);
	WRITE_COLOR(hilightColor, hilightColor);
	WRITE_COLOR(linkColor, linkColor);

	return true;
}

void CPHConfigDlg::OnButtonRedraw() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	writeConfig(m_tmpfile);
	m_eq.loadConf(m_tmpfile);
}



#define ARRAY_SIZE(ARY) (sizeof(ARY)/sizeof(ARY[0]))

struct SampleCmpnt
{
	char *title;
	char *fname;
	bool enumerate;
	bool enable;
};


static SampleCmpnt s_samples[] = {
	{ "ϐ", "param.math", false, false},
	{ "֐", "func.math", false, false},
	{  "Zq", "op.math", false, false},
	{ "傫L", "big.math", false, false},
	{ "ԍ", "enum.math", true, false},
	{ "ʗ", "bracket.math", false, false},
	{ "̑", "misc.math", false, false},
	{ "t@Cw", 0, false, true}, 
};

void CPHConfigDlg::showSampleList()
{
	int n = ARRAY_SIZE(s_samples);
	for (int i=0; i<n; i++) {
		m_samples.AddString(s_samples[i].title);
	}
	selectSample(0);
}

void CPHConfigDlg::selectSample(int n)
{
	if (n < 0) {
		n = m_samples.GetCurSel();
		if (n == CB_ERR) { return; }
	}

	SampleCmpnt *p = &s_samples[n];
	m_samples.SelectString(-1, p->title);
	m_eq.SetEnumeration(p->enumerate);

	bool b = p->enable;
	GetDlgItem(IDC_EDIT_EQUATION_FILE)->EnableWindow(b);
	GetDlgItem(IDC_BUTTON_SELECT_FILE)->EnableWindow(b);

	if (p->fname) {
		m_eq.SetFilename(p->fname);
	} 

}

void CPHConfigDlg::OnSelchangeComboSampleList() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉ
	// Ă
	selectSample();
}

void CPHConfigDlg::OnButtonSetDefault() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	::CopyFile(m_inifile, m_defaultfile, FALSE);
}

void CPHConfigDlg::OnButtonDefault() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	::CopyFile(m_defaultfile, m_inifile, FALSE);

	loadConfig();
	m_eq.loadConf(m_inifile);
}

void CPHConfigDlg::OnButtonSelectFile() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog dlg(TRUE);
	if (dlg.DoModal() == IDOK) {
		CString fname = dlg.GetPathName();
		GetDlgItem(IDC_EDIT_EQUATION_FILE)->SetWindowText(fname);
		m_eq.SetFilename(fname);
	}
	
}

void CPHConfigDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	writeConfig(this->m_inifile);
	
	CDialog::OnOK();
}

void CPHConfigDlg::OnButtonSave() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
}
