// PHMath2D.cpp : CPHMath2DApp NX̃Cve[V DLL ̓o^s܂B

#include "stdafx.h"
#include "PHMath2D.h"

#include "Math2DWinDrawer.h"
#include "ResourceBitmapObjectCreator.h"
#include "EquationImageFactory.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CPHMath2DApp NEAR theApp;

const GUID CDECL BASED_CODE _tlid =
		{ 0x5c00cae7, 0x1d44, 0x4719, { 0xb6, 0x3d, 0xb0, 0xd3, 0xfb, 0x77, 0xa6, 0x64 } };
const WORD _wVerMajor = 1;
const WORD _wVerMinor = 0;


////////////////////////////////////////////////////////////////////////////
// CPHMath2DApp::InitInstance - DLL ̏



static ResourceBitmapObjectCreator *creators[EquationImageFactory::IMAGE_TYPE_NUM];
static int creator_num = 0;

#define SET_IMAGE(hInst, type, ID)  {\
	ResourceBitmapObjectCreator *p = new ResourceBitmapObjectCreator(hInst, ID); \
	EquationImageFactory::set(type, p); \
	creators[creator_num++] = p;\
}


BOOL CPHMath2DApp::InitInstance()
{
	BOOL bInit = COleControlModule::InitInstance();

	if (bInit)
	{
		// TODO: ̈ʒuɃW[̏R[hǉĂB
		Math2DWinDrawer::initDrawer();
		EquationImageFactory::init();
		HINSTANCE hInst = this->m_hInstance;
#if 1
#define DEF_IMAGE_RESOURCE(TYPE, ID) SET_IMAGE(hInst, EquationImageFactory::TYPE, ID)
#include "ImageResource.h"
#else
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_NOTIN, IDB_NOTIN);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_PLUS_MINUS, IDB_PM);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_MINUS_PLUS, IDB_MP);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_LESS_EQUAL, IDB_LE);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_GREATER_EQUAL, IDB_GE);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_APPROX, IDB_APPROX);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_DOUBLE_LEFT_ARROW,
			  IDB_DOUBLE_LEFT_ARROW);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_DOUBLE_UP_ARROW,
			  IDB_DOUBLE_UP_ARROW);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_DOUBLE_DOWN_ARROW,
			  IDB_DOUBLE_DOWN_ARROW);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_EPSILON,
			  IDB_EPSILON);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_VARIANT_THETA,
			  IDB_VARTHETA);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_VARIANT_PI,
			  IDB_VARPI);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_VARIANT_RHO,
			  IDB_VARRHO);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_VARIANT_SIGMA,
			  IDB_VARSIGMA);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_VARIANT_PHI,
			  IDB_VARPHI);
		SET_IMAGE(hInst, EquationImageFactory::IMAGE_ELL,
			  IDB_ELL);
#endif 
	}

	return bInit;
}


////////////////////////////////////////////////////////////////////////////
// CPHMath2DApp::ExitInstance - DLL ̏I

int CPHMath2DApp::ExitInstance()
{
	// TODO: ̈ʒuɃW[̏IǉĂB
	EquationImageFactory::free_();
	Math2DWinDrawer::freeDrawer();
	creator_num = 0;

	return COleControlModule::ExitInstance();
}


/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - VXe WXg̃Ggǉ

STDAPI DllRegisterServer(void)
{
	AFX_MANAGE_STATE(_afxModuleAddrThis);

	if (!AfxOleRegisterTypeLib(AfxGetInstanceHandle(), _tlid))
		return ResultFromScode(SELFREG_E_TYPELIB);

	if (!COleObjectFactoryEx::UpdateRegistryAll(TRUE))
		return ResultFromScode(SELFREG_E_CLASS);

	return NOERROR;
}


/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - VXe WXg̃Gg폜

STDAPI DllUnregisterServer(void)
{
	AFX_MANAGE_STATE(_afxModuleAddrThis);

	if (!AfxOleUnregisterTypeLib(_tlid, _wVerMajor, _wVerMinor))
		return ResultFromScode(SELFREG_E_TYPELIB);

	if (!COleObjectFactoryEx::UpdateRegistryAll(FALSE))
		return ResultFromScode(SELFREG_E_CLASS);

	return NOERROR;
}
