/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: CharacterDCDrawer.h,v 1.2 2004/02/19 08:31:39 yoshi Exp $ */ 
#ifndef CharacterDCDrawer_h
#define CharacterDCDrawer_h

#include <windows.h>

#include "TextRect.h"
#include "DCDrawType.h"
#include "EquationDCDrawerUtil.h"

class CharacterDCDrawer
{
private:
	HDC	m_dc;
	HFONT	m_origFont;
	TextRect *m_rect;
public:
	CharacterDCDrawer(HDC dc, HFONT f) : m_dc(dc), m_origFont(0), m_rect(0)
	{
		m_origFont = (HFONT)::SelectObject(dc, f);
	}
	~CharacterDCDrawer()
	{
		::SelectObject(m_dc, m_origFont);
		if (m_rect) { delete m_rect; m_rect = 0; }
	}

	void	draw(int sx, int sy, char *str)
	{
		::TextOut(m_dc, sx, sy, str, strlen(str));
	}
	RectSize &size(char *str, RectSize &rs)
	{
		EquationDCDrawerUtil::calcTextRect(m_dc, str, rs);
		return rs;
	}
		
	int	heightInnerStart(int height)
	{
		if (!m_rect) { m_rect = new TextRect(m_dc); }
		return m_rect->heightInnerStart(height);
	}

	int	heightInnerEnd(int height)
	{
		if (!m_rect) { m_rect = new TextRect(m_dc); }
		return m_rect->heightInnerEnd(height);
	}
};


#endif // CharacterDCDrawer_h
 
