/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: ConditionEquationDCDrawer.cpp,v 1.4 2002/09/03 07:26:56 yoshi Exp $ */ 
#include "ConditionEquationDCDrawer.h"
#include "ConditionEquation.h"
#include "DrawContext.h"
#include "EquationSizeManager.h"

static DrawContext &createContext(DrawContext &parent, DrawContext &new_context)
{
	new_context = parent;
	return new_context;
}

#define contentContext createContext

static int leftMargin(DrawContext *context)
{
	EquationSizeManager::Size &sz = context->sizeMgr->size(context->level);
	return sz.width * 3;
}

//#define DEBUG_DRAW
#include "EquationDCDrawerUtil.h"

void ConditionEquationDCDrawer::draw(Equation *eq, DrawContext *context)
{
	DEBUG_DRAW_RECT(eq, context);
	Equation::Size *whole_sz = eq->size(context);
	ConditionEquation *cond = static_cast<ConditionEquation*>(eq);

	DrawContext content_context;
	contentContext(*context, content_context);
	content_context.point.x.setEnd(context->point.x.end(whole_sz->widthLength()));
	content_context.point.y.setCenter(context->point.y.center(whole_sz->widthLength()));
	Equation *content = cond->content();
	content->draw(&content_context);
}

void ConditionEquationDCDrawer::size(Equation *eq, DrawContext *context, Equation::Size &sz)
{
	ConditionEquation *cond = static_cast<ConditionEquation*>(eq);

	int	width = 0;
	Length	height;
	DrawContext content_context;
	contentContext(*context, content_context);
	Equation *content = cond->content();
	Equation::Size *content_sz = content->size(&content_context);
	width = content_sz->width(); height = content_sz->heightLength();

	int	left_margin = leftMargin(&content_context);
	int	x_center = left_margin + width/2;
	width += left_margin;
	sz.set(width, height.value());
	sz.setCenter(x_center, height.start_center());
}
