/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: DrawContext.h,v 1.7 2003/10/02 03:59:00 yoshi Exp $ */ 
#ifndef DrawContext_h
#define DrawContext_h

#include "DrawLevel.h"
#include "DrawPosition.h"
#include "FontManager.h"

class ViewBuffer;
class EquationSizeManager;
class EquationDictionaryBase;
class HilightSwitch;
class EquationRegister;

class DrawContext
{
private:
	class DrawPoint
	{
	public:
		DrawPosition	x;
		DrawPosition	y;
	};

	class Align
	{
	public:
		DrawPosition	x;
	};
public:
	ViewBuffer	*buffer;
	DrawPoint	point;
	DrawLevel	level;
	bool		bold;
	bool		margin;
	bool		tag;
	bool		alignSet;
	Align		align;
private:
	Length		m_centerWidth;
public:

	EquationSizeManager	*sizeMgr;
	FontManager		*fontMgr;
	HilightSwitch		*hilightSwitch;
	EquationDictionaryBase	*dictionary;
	int			m_enum;

	EquationRegister	*eqRegister;

private:
	void	init();
public:
	DrawContext();
	DrawContext(EquationSizeManager *	sizeM_,
		    FontManager *		fontM_,
		    HilightSwitch *		hilightS_,
		    EquationDictionaryBase *	dic_,
		    EquationRegister *		eqReg,
		    int				enum_ = 1);

	void	start(ViewBuffer *);
	void	end();

	void	setXAlignment(int x);
	void	centerWidth(Length &l) { m_centerWidth = l; }
	int	centerWidth() { return m_centerWidth.value(); }
	int	alignRightStartX(Length &width);
	int	alignLeftEndX(Length &width);
	HFONT	getFont(FontManager::FontType t);
	bool	enumerate() { return (m_enum >= 0)? true: false; }
	int	number() { return m_enum++; }
	void	link(bool b);
};

#endif  // DrawContext_h
