/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: EquationCharacterDCDrawerImpl.h,v 1.1 2004/02/19 08:30:53 yoshi Exp $ */ 
#ifndef EquationCharacterDCDrawerImpl_h
#define EquationCharacterDCDrawerImpl_h

#include "OperatorEquationCharacterDCDrawer.h"

#define DECLARE_CHARACTER_EQUATION(CLASS, BASE, STR) \
class CLASS : public BASE { private: char *toString(Equation *) { static char *str = STR; return str; } }

DECLARE_CHARACTER_EQUATION(EqualEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(EquivalentEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(GreaterGreaterEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(LessLessEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(GreaterEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "r");
DECLARE_CHARACTER_EQUATION(LessEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "q");
DECLARE_CHARACTER_EQUATION(InEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(NotEqualEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(PrimeEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "\'");
DECLARE_CHARACTER_EQUATION(ProptoEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(SimilarEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "`");
DECLARE_CHARACTER_EQUATION(SubsetEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(SupsetEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(PerpEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(ParallelEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "a");
DECLARE_CHARACTER_EQUATION(VDashEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(DashVEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");


DECLARE_CHARACTER_EQUATION(PlusEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "{");
DECLARE_CHARACTER_EQUATION(MinusEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "|");
DECLARE_CHARACTER_EQUATION(TimesEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "~");
DECLARE_CHARACTER_EQUATION(DivEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(AsteriskEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(StarEquationDCDrawer, OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(CircEquationDCDrawer, OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(BulletEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(CDotEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "E");
DECLARE_CHARACTER_EQUATION(CapEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(CupEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(DiamondEquationDCDrawer, OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(VeeEquationDCDrawer, OperatorEquationCharacterDCDrawer, "");
typedef VeeEquationDCDrawer LorEquationDCDrawer;
DECLARE_CHARACTER_EQUATION(WedgeEquationDCDrawer, OperatorEquationCharacterDCDrawer, "");
typedef WedgeEquationDCDrawer LandEquationDCDrawer;
DECLARE_CHARACTER_EQUATION(DaggerEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(DoubleDaggerEquationDCDrawer, OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(BigCircEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(BigTriangleUpEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");
DECLARE_CHARACTER_EQUATION(BigTriangleDownEquationDCDrawer,
			   OperatorEquationCharacterDCDrawer, "");



#undef DECLARE_CHARACTER_EQUATION

#endif // EquationCharacterDCDrawerImpl_h
 
