/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: EquationDCDrawerUtil.cpp,v 1.9 2004/02/16 12:58:41 yoshi Exp $ */ 
#include <windows.H>
#include "EquationDCDrawerUtil.h"

bool EquationDCDrawerUtil::calcTextRect(HDC hDC, const char *str, SIZE &size)
{
	return (::GetTextExtentPoint32(hDC, str, strlen(str), &size))? true: false;
}

#ifdef _DEBUG

#include "Equation.h"
#include "DrawContext.h"
#include "ViewBuffer.h"

#define DRAW_LINE(HDC, sx, sy, ex, ey) { ::MoveToEx(hDC, sx, sy, 0); ::LineTo(hDC, ex, ey); }

void EquationDCDrawerUtil::drawRect(Equation *eq, DrawContext *context)
{
	HDC hDC = context->buffer->getDC();
	Equation::Size *sz = eq->size(context);
	HPEN hPen = CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
	HPEN hOrigPen = (HPEN)SelectObject(hDC, hPen);

	int sx = context->point.x.start(sz->widthLength());
	int ex = context->point.x.end(sz->widthLength());
	int sy = context->point.y.start(sz->heightLength());
	int ey = context->point.y.end(sz->heightLength());
	::Rectangle(hDC, sx, sy, ex, ey);
	int cx = context->point.x.center(sz->widthLength());
	int cy = context->point.y.center(sz->heightLength());
	DRAW_LINE(hDC, sx, cy, ex, cy);
	DRAW_LINE(hDC, cx, sy, cx, ey);
	SelectObject(hDC, hOrigPen);
	DeleteObject(hPen);
}
#endif

