/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: EquationImageObjectDCDrawerImpl.h,v 1.2 2004/02/19 12:54:11 yoshi Exp $ */ 
#ifndef EquationImageObjectDCDrawerImpl_h
#define EquationImageObjectDCDrawerImpl_h

#include "EquationImageObjectDCDrawerTmp.h"
#include "EquationSizeManager.h"
#include "DrawContext.h"

#define DECLARE_DRAWER_WITH_LAYOUT(CLASS, IMAGE, SX, SY, EX, EY, WIDTH) \
class CLASS : public EquationImageObjectDCDrawerTmp<EquationImageFactory::##IMAGE##> { \
private: typedef EquationImageObjectDCDrawerTmp<EquationImageFactory::##IMAGE##> Super; \
public: CLASS() : Super() { layout(SX, SY, EX, EY); } \
private: \
	void size(Equation *, DrawContext *context, Equation::Size &sz) { \
	EquationSizeManager::Size &char_sz = context->sizeMgr->size(context->level); \
	int	width = WIDTH*char_sz.width; \
	int	height = char_sz.height; \
	sz.set(width, height); }\
};

#define DEFAULT_SX 0.1
#define DEFAULT_SY 0.2
#define DEFAULT_EX 0.1
#define DEFAULT_EY 0.2
#define DEFAULT_WIDTH 2

#undef DECLARE_DRAWER
#define DECLARE_DRAWER(CLASS, IMAGE) DECLARE_DRAWER_WITH_LAYOUT(CLASS, IMAGE, DEFAULT_SX, DEFAULT_SY, DEFAULT_EX, DEFAULT_EY, DEFAULT_WIDTH);


/************************************

      Binominal Operator

*************************************/
#define DECLARE_BIOP_DRAWER(CLASS, IMAGE) DECLARE_DRAWER_WITH_LAYOUT(CLASS, IMAGE, 0.2, 0.1, 0.2, 0.1, 2)
//#define DECLARE_BIOP_DRAWER DECLARE_DRAWER
DECLARE_BIOP_DRAWER(PlusMinusEquationDCDrawer, IMAGE_PLUS_MINUS);
DECLARE_BIOP_DRAWER(MinusPlusEquationDCDrawer, IMAGE_MINUS_PLUS);
DECLARE_BIOP_DRAWER(UPlusEquationDCDrawer, IMAGE_UPLUS);
DECLARE_BIOP_DRAWER(SqCapEquationDCDrawer, IMAGE_SQCAP);
DECLARE_BIOP_DRAWER(SqCupEquationDCDrawer, IMAGE_SQCUP);
DECLARE_DRAWER_WITH_LAYOUT(SetMinusEquationDCDrawer, IMAGE_SETMINUS, 0.2, 0.0, 0.2, 0.0, 1);
DECLARE_DRAWER_WITH_LAYOUT(WREquationDCDrawer, IMAGE_WR, 0.2, 0.0, 0.2, 0.0, 1);
DECLARE_DRAWER_WITH_LAYOUT(TriangleLeftEquationDCDrawer, IMAGE_TRIANGLE_LEFT, 0.3, 0.3, 0.3, 0.3, 2);
DECLARE_DRAWER_WITH_LAYOUT(TriangleRightEquationDCDrawer, IMAGE_TRIANGLE_RIGHT, 0.3, 0.3, 0.3, 0.3, 2);
DECLARE_BIOP_DRAWER(LHDEquationDCDrawer, IMAGE_LHD);
DECLARE_BIOP_DRAWER(RHDEquationDCDrawer, IMAGE_RHD);
DECLARE_BIOP_DRAWER(UnLHDEquationDCDrawer, IMAGE_UNLHD);
DECLARE_BIOP_DRAWER(UnRHDEquationDCDrawer, IMAGE_UNRHD);
DECLARE_BIOP_DRAWER(OPlusEquationDCDawer, IMAGE_OPLUS);
DECLARE_BIOP_DRAWER(OMinusEquationDCDrawer, IMAGE_OMINUS);
DECLARE_BIOP_DRAWER(OTimesEquationDCDrawer, IMAGE_OTIMES);
DECLARE_BIOP_DRAWER(OSlashEquationDCDrawer, IMAGE_OSLASH);
DECLARE_BIOP_DRAWER(ODotEquationDCDrawer, IMAGE_ODOT);
DECLARE_BIOP_DRAWER(AmalgEquationDCDrawer, IMAGE_AMALG);

/************************************

      Comparative  Operator

*************************************/
#define DECLARE_COMPOP_DRAWER(CLASS, IMAGE) DECLARE_DRAWER_WITH_LAYOUT(CLASS, IMAGE, 0.2, 0.1, 0.2, 0.1, 2)
DECLARE_COMPOP_DRAWER(ApproxEquationDCDrawer, IMAGE_APPROX);
DECLARE_COMPOP_DRAWER(LessEqualEquationDCDrawer, IMAGE_LE);
DECLARE_COMPOP_DRAWER(GreaterEqualEquationDCDrawer, IMAGE_GE);
DECLARE_DRAWER_WITH_LAYOUT(NotinEquationDCDrawer, IMAGE_NOTIN, 0.2, 0.1, 0.2, 0.1, 2);
DECLARE_COMPOP_DRAWER(PrecEquationDCDrawer, IMAGE_PREC);
DECLARE_COMPOP_DRAWER(PrecEqEquationDCDrawer, IMAGE_PRECEQ);
DECLARE_COMPOP_DRAWER(SuccEquationDCDrawer, IMAGE_SUCC);
DECLARE_COMPOP_DRAWER(SuccEqualEquationDCDrawer, IMAGE_SUCCEQ);

DECLARE_COMPOP_DRAWER(SubsetEqualEquationDCDrawer, IMAGE_SUBSETEQ);
DECLARE_COMPOP_DRAWER(SupsetEqualEquationDCDrawer, IMAGE_SUPSETEQ);

DECLARE_COMPOP_DRAWER(SquareSubsetEquationDCDrawer, IMAGE_SQSUBSET);
DECLARE_COMPOP_DRAWER(SquareSubsetEqualEquationDCDrawer, IMAGE_SQSUBSETEQ);
DECLARE_COMPOP_DRAWER(SquareSupsetEquationDCDrawer, IMAGE_SQSUPSET);
DECLARE_COMPOP_DRAWER(SquareSupsetEqualEquationDCDrawer, IMAGE_SQSUPSETEQ);

DECLARE_COMPOP_DRAWER(NiEquationDCDrawer, IMAGE_NI);

DECLARE_COMPOP_DRAWER(SimilarEqualEquationDCDrawer, IMAGE_SIMEQ);
DECLARE_COMPOP_DRAWER(AsympEquationDCDrawer, IMAGE_ASYMP);
DECLARE_COMPOP_DRAWER(CongEquationDCDrawer, IMAGE_CONG);
DECLARE_COMPOP_DRAWER(DotEqualEquationDCDrawer, IMAGE_DOTEQ);
DECLARE_COMPOP_DRAWER(ModelsEquationDCDrawer, IMAGE_DOTEQ);
DECLARE_COMPOP_DRAWER(BowtieEquationDCDrawer, IMAGE_BOWTIE);
DECLARE_COMPOP_DRAWER(JoinEquationDCDrawer, IMAGE_JOIN);
DECLARE_DRAWER_WITH_LAYOUT(SmileEquationDCDrawer, IMAGE_SMILE, 0.2, 0.3, 0.2, 0.3, 2);
DECLARE_DRAWER_WITH_LAYOUT(FrownEquationDCDrawer, IMAGE_FROWN, 0.2, 0.3, 0.2, 0.3, 2);


/*******************

      Arrow

 *******************/
  
DECLARE_DRAWER(SingleLeftArrowEquationDCDrawer, IMAGE_SINGLE_LEFT_ARROW);
DECLARE_DRAWER(SingleRightArrowEquationDCDrawer, IMAGE_SINGLE_RIGHT_ARROW);
DECLARE_DRAWER(SingleLeftRightArrowEquationDCDrawer, IMAGE_SINGLE_LEFT_RIGHT_ARROW);

#define DECLARE_VERTICAL_ARROW_DRAWER(CLASS, IMAGE) DECLARE_DRAWER_WITH_LAYOUT(CLASS, IMAGE, 0.3, 0, 0.3, 0, DEFAULT_WIDTH)

DECLARE_VERTICAL_ARROW_DRAWER(SingleUpArrowEquationDCDrawer, IMAGE_SINGLE_UP_ARROW);
DECLARE_VERTICAL_ARROW_DRAWER(SingleDownArrowEquationDCDrawer, IMAGE_SINGLE_DOWN_ARROW);

#define DECLARE_LONG_ARROW_DRAWER(CLASS, IMAGE) DECLARE_DRAWER_WITH_LAYOUT(CLASS, IMAGE, 0.0, 0.1, 0.0, 0.1, 3);
DECLARE_LONG_ARROW_DRAWER(LongSingleLeftArrowEquationDCDrawer, IMAGE_LONG_SINGLE_LEFT_ARROW);
DECLARE_LONG_ARROW_DRAWER(LongSingleRightArrowEquationDCDrawer, IMAGE_LONG_SINGLE_RIGHT_ARROW);
DECLARE_LONG_ARROW_DRAWER(LongSingleLeftRightArrowEquationDCDrawer, IMAGE_LONG_SINGLE_LEFT_RIGHT_ARROW);

DECLARE_LONG_ARROW_DRAWER(LongDoubleLeftArrowEquationDCDrawer, IMAGE_LONG_DOUBLE_LEFT_ARROW);
DECLARE_LONG_ARROW_DRAWER(LongDoubleRightArrowEquationDCDrawer, IMAGE_LONG_DOUBLE_RIGHT_ARROW);
DECLARE_LONG_ARROW_DRAWER(LongDoubleLeftRightArrowEquationDCDrawer, IMAGE_LONG_DOUBLE_LEFT_RIGHT_ARROW);

#define DECLARE_DOUBLE_ARROW_DRAWER(CLASS, IMAGE) DECLARE_DRAWER_WITH_LAYOUT(CLASS, IMAGE, DEFAULT_SX, 0.1, DEFAULT_EX, 0.1, DEFAULT_WIDTH)

DECLARE_DOUBLE_ARROW_DRAWER(DoubleLeftArrowEquationDCDrawer, IMAGE_DOUBLE_LEFT_ARROW);
DECLARE_DOUBLE_ARROW_DRAWER(DoubleRightArrowEquationDCDrawer, IMAGE_DOUBLE_RIGHT_ARROW);
DECLARE_DOUBLE_ARROW_DRAWER(DoubleLeftRightArrowEquationDCDrawer, IMAGE_DOUBLE_LEFT_RIGHT_ARROW);

DECLARE_DRAWER(MapstoArrowEquationDCDrawer, IMAGE_MAPSTO);
DECLARE_DRAWER_WITH_LAYOUT(LongMapstoArrowEquationDCDrawer, IMAGE_MAPSTO, DEFAULT_SX, DEFAULT_SY, DEFAULT_EX, DEFAULT_EY, 3);
DECLARE_DRAWER(LeadsToArrowEquationDCDrawer, IMAGE_LEADSTO);

DECLARE_DRAWER_WITH_LAYOUT(LeftHarpoonUpArrowEquationDCDrawer, IMAGE_LEFT_HARPOON_UP, DEFAULT_SX, 0.1, DEFAULT_EX, 0.5, DEFAULT_WIDTH);
DECLARE_DRAWER_WITH_LAYOUT(RightHarpoonUpArrowEquationDCDrawer, IMAGE_RIGHT_HARPOON_UP, DEFAULT_SX, 0.1, DEFAULT_EX, 0.5, DEFAULT_WIDTH);
DECLARE_DRAWER_WITH_LAYOUT(LeftHarpoonDownArrowEquationDCDrawer, IMAGE_LEFT_HARPOON_DOWN, DEFAULT_SX, 0.5, DEFAULT_EX, 0.1, DEFAULT_WIDTH);
DECLARE_DRAWER_WITH_LAYOUT(RightHarpoonDownArrowEquationDCDrawer, IMAGE_RIGHT_HARPOON_DOWN, DEFAULT_SX, 0.5, DEFAULT_EX, 0.1, DEFAULT_WIDTH);
DECLARE_DRAWER(RightLeftHarpoonsArrowEquationDCDrawer, IMAGE_RIGHT_LEFT_HARPOON);

DECLARE_DRAWER(HookRightArrowEquationDCDrawer, IMAGE_HOOK_RIGHT);
DECLARE_DRAWER(HookLeftArrowEquationDCDrawer, IMAGE_HOOK_LEFT);

#define DECLARE_DIRECTION_ARROW_DRAWER(CLASS, IMAGE) DECLARE_DRAWER_WITH_LAYOUT(CLASS, IMAGE, DEFAULT_SX, 0.1, DEFAULT_EX, 0.0, DEFAULT_WIDTH);

DECLARE_DIRECTION_ARROW_DRAWER(SEArrowEquationDCDrawer, IMAGE_SEARROW);
DECLARE_DIRECTION_ARROW_DRAWER(SWArrowEquationDCDrawer, IMAGE_SWARROW);
DECLARE_DIRECTION_ARROW_DRAWER(NWArrowEquationDCDrawer, IMAGE_NWARROW);
DECLARE_DIRECTION_ARROW_DRAWER(NEArrowEquationDCDrawer, IMAGE_NEARROW);


/*******************

      Misc

 *******************/

#define DECLARE_MISC_DRAWER(CLASS, IMAGE) DECLARE_DRAWER_WITH_LAYOUT(CLASS, IMAGE, DEFAULT_SX, DEFAULT_SY, DEFAULT_EX, DEFAULT_EY, 1);
DECLARE_MISC_DRAWER(ReEquationDCDrawer, IMAGE_RE);
DECLARE_MISC_DRAWER(ImEquationDCDrawer, IMAGE_IM);
DECLARE_DRAWER_WITH_LAYOUT(IMathEquationDCDrawer, IMAGE_IMATH, 0.2, 0.3, 0.2, 0.1, 1);
DECLARE_DRAWER_WITH_LAYOUT(JMathEquationDCDrawer, IMAGE_JMATH, 0.2, 0.3, 0.2, 0.1, 1);
DECLARE_MISC_DRAWER(AlephEquationDCDrawer, IMAGE_ALEPH);
DECLARE_MISC_DRAWER(HBarEquationDCDrawer, IMAGE_HBAR);
DECLARE_DRAWER_WITH_LAYOUT(EmptySetEquationDCDrawer, IMAGE_EMPTYSET, 0.2, DEFAULT_SY, 0.2, DEFAULT_EY, 1);
DECLARE_DRAWER_WITH_LAYOUT(WPEquationDCDrawer, IMAGE_WP, 0.2, DEFAULT_SY, 0.2, DEFAULT_EY, 1);
DECLARE_MISC_DRAWER(NablaEquationDCDrawer, IMAGE_NABLA);
DECLARE_MISC_DRAWER(SurdEquationDCDrawer, IMAGE_SURD);
DECLARE_DRAWER_WITH_LAYOUT(EllEquationDCDrawer, IMAGE_ELL, 0.2, 0.1, 0.2, 0.1, 1);
DECLARE_DRAWER_WITH_LAYOUT(NaturalEquationDCDrawer, IMAGE_NATURAL, 0.2, 0.1, 0.2, 0.1, 1);
DECLARE_MISC_DRAWER(SpadeSuitEquationDCDrawer, IMAGE_SPADE_SUIT);
DECLARE_MISC_DRAWER(HeartSuitEquationDCDrawer, IMAGE_HEART_SUIT);
DECLARE_MISC_DRAWER(ClubSuitEquationDCDrawer, IMAGE_CLUB_SUIT);
DECLARE_MISC_DRAWER(DiamondSuitEquationDCDrawer, IMAGE_DIAMOND_SUIT);

#undef DECLARE_DRAWER


#endif // EquationImageObjectDCDrawerImpl_h
 
