/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: EquationOverWriteDCDrawer.cpp,v 1.8 2003/05/08 07:08:27 yoshi Exp $ */ 
#include "EquationOverWriteDCDrawer.h"
#include "Equation.h"
#include "DrawContext.h"
#include "EquationSizeManager.h"

DrawContext &EquationOverWriteDCDrawer::
createContext(DrawContext &parent, DrawContext &new_context)
{
	new_context = parent;
	return new_context;
}

DrawContext &EquationOverWriteDCDrawer::
firstContext(DrawContext &parent, DrawContext &new_context)
{
	return createContext(parent, new_context);
}

DrawContext &EquationOverWriteDCDrawer::
secondContext(DrawContext &parent, DrawContext &new_context)
{
	return createContext(parent, new_context);
}

//#define DEBUG_DRAW	
#include "EquationDCDrawerUtil.h"

#define UPPER_SHIFTRATE 5
#define RIGHT_SHIFTRAGE 4

void	EquationOverWriteDCDrawer::draw(Equation *eq, DrawContext *context)
{
	DEBUG_DRAW_RECT(eq, context);
	Equation::Size *whole_sz = eq->size(context);
	int	cx = context->point.x.center(whole_sz->width());
	Equation *first_eq = first(eq);

	DrawContext first_context;
	firstContext(*context, first_context);
	first_context.point.x.setCenter(cx);
	first_context.point.y.setEnd(context->point.y.end(whole_sz->heightLength()));
	DEBUG_DRAW_RECT(first_eq, &first_context);
	first_eq->draw(&first_context);

	Equation *second_eq = second(eq);
	DrawContext second_context;
	secondContext(first_context, second_context);
	EquationSizeManager::Size &normal_sz = second_context.sizeMgr->size(second_context.level);
	second_context.point.x.setCenter(cx + normal_sz.width/RIGHT_SHIFTRAGE); // 1/4 Eɂ炷B
	second_context.point.y.shift(-normal_sz.height/UPPER_SHIFTRATE);
	second_eq->draw(&second_context);
}

void	EquationOverWriteDCDrawer::size(Equation *eq, DrawContext *context, Equation::Size &sz)
{
	Equation *first_eq = first(eq);

	DrawContext first_context;
	firstContext(*context, first_context);
	Equation::Size *first_sz = first_eq->size(&first_context);
	int	width = first_sz->width();
	int	height = first_sz->height();
	DrawContext second_context;
	secondContext(first_context, second_context);
	EquationSizeManager::Size &normal_sz = second_context.sizeMgr->size(second_context.level);
	int second_height = normal_sz.height/UPPER_SHIFTRATE;
	width += normal_sz.width/RIGHT_SHIFTRAGE;
	height += second_height;

	sz.set(width, height);
	sz.setCenter(width/2,
		     second_height + first_sz->heightLength().start_center());
}

