/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: EquationSizeManager.cpp,v 1.8 2002/06/20 10:30:45 yoshi Exp $ */ 
#include <assert.h>
#include "EquationSizeManager.h"
#include "EquationSizeDef.h"

#ifndef _DEBUG

#define SIZE1 Size1
#define SIZE2 Size2
#define SIZE3 Size4
#define SIZE4 Size4
#define SIZE5 Size5
#define SIZE6 Size6
#define SIZE7 Size7

#else // debug p

#define SIZE1 Size6
#define SIZE2 Size6
#define SIZE3 Size6
#define SIZE4 Size6
#define SIZE5 Size6
#define SIZE6 Size6
#define SIZE7 Size6

#endif

#define SET_SIZE(SIZE) { \
	int	i = 0; \
	m_sizes[i].set(SIZE::DRAWLEVEL0_WIDTH, SIZE::DRAWLEVEL0_HEIGHT); i++; \
	m_sizes[i].set(SIZE::DRAWLEVEL1_WIDTH, SIZE::DRAWLEVEL1_HEIGHT); i++; \
	m_sizes[i].set(SIZE::DRAWLEVEL2_WIDTH, SIZE::DRAWLEVEL2_HEIGHT); i++; \
	m_sizes[i].set(SIZE::DRAWLEVEL3_WIDTH, SIZE::DRAWLEVEL3_HEIGHT); i++; \
}

#define SIZE_SWITCH_START(n) switch(n) {
#define SIZE_CASE(n, SIZE) case n: SET_SIZE(SIZE); break
#define SIZE_DEFAULT(SIZE) default: SET_SIZE(SIZE); break
#define SIZE_SWITCH_END() }
	

void	EquationSizeManager::init(int size)
{
	SIZE_SWITCH_START(size);
	SIZE_CASE(1, SIZE1);
	SIZE_CASE(2, SIZE2);
	SIZE_CASE(3, SIZE3);
	SIZE_CASE(4, SIZE4);
	SIZE_CASE(5, SIZE5);
	SIZE_CASE(6, SIZE6);
	SIZE_CASE(7, SIZE7);
	SIZE_DEFAULT(SIZE3);
	SIZE_SWITCH_END();
}
#ifdef _DEBUG
void	EquationSizeManager::checkRange(DrawLevel l)
{
	assert(0 <= l);
	assert(l < DRAWLEVEL_NUM);
}
#endif


EquationSizeManager::Size &EquationSizeManager::bracketSize(DrawLevel level)
{
	checkRange(level);

	DrawLevel bracket_level;
	switch(level) {
	case DRAWLEVEL0:
		bracket_level = DRAWLEVEL1; break;
	case DRAWLEVEL1:
	case DRAWLEVEL2:
		bracket_level = level; break;
	default:
		assert(0);
	}
	return size(bracket_level);
}
