/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: FontManager.h,v 1.8 2003/09/12 06:58:23 yoshi Exp $ */ 
#ifndef FontManager_h
#define FontManager_h

#ifdef WIN32

#include <windows.h>
#include "DrawLevel.h"

class EquationSizeManager;

class FontManager
{
public:
	enum FontType {
		FONT_TYPE_NOT_SET = -1,
		MATH_STRING_NORMAL,
		MATH_BIG_SYMBOL,
		MATH_OPERATOR,
		MATH_FUNCTION,
		MATH_PARAM,
		BRACKET,
		ARROW,
		ENUMERATION,
		FONT_NUM,
	};

	enum WeightType { WEIGHT_NOT_SET = -1, WEIGHT_NORMAL, WEIGHT_BOLD, WEIGHT_NUM, };

private:
	EquationSizeManager	*m_sizeMgr;
	char	*m_fontnames[FONT_NUM];
	LOGFONT	m_logFontArray[FONT_NUM][DRAWLEVEL_NUM][WEIGHT_NUM];
	HFONT	m_fontArray[FONT_NUM][DRAWLEVEL_NUM][WEIGHT_NUM];

private:
	void	init();
	void	free_();
	void	freeFont();

	HFONT createFont(FontManager::FontType type, DrawLevel level, WeightType weight);
	HFONT createFont(FontManager::FontType type, int width, int height);
public:
	FontManager() : m_sizeMgr(0) { init(); }
	virtual ~FontManager() { free_(); }

	void	set(EquationSizeManager *p) { m_sizeMgr = p; }
	void	setFontName(FontType, const char *fontname);

	void	initFont();

	HFONT	getFont(FontType, DrawLevel, WeightType);
	HFONT	getFont(FontType, int width, int height);
};

#endif	// WIN32

#endif  // FontManager_h
