/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: GreekCharacterDCDrawer.cpp,v 1.4 2004/02/19 08:37:13 yoshi Exp $ */ 
#include "GreekCharacterDCDrawer.h"
#include "GreekCharacter.h"
#include "GreekCharacterCharacterDCDrawer.h"
#include "EpsilonGreekCharacterDCDrawer.h"
#include "EquationImageObjectDCDrawerTmp.h"
#include "EquationImageFactory.h"

class VariantPhiGreekCharacterDCDrawer : public EquationImageObjectDCDrawerTmp<EquationImageFactory::IMAGE_VARIANT_PHI>{};
class VariantPiGreekCharacterDCDrawer : public EquationImageObjectDCDrawerTmp<EquationImageFactory::IMAGE_VARIANT_PI> {};
class VariantRhoGreekCharacterDCDrawer : public EquationImageObjectDCDrawerTmp<EquationImageFactory::IMAGE_VARIANT_RHO> {};
class VariantSigmaGreekCharacterDCDrawer : public EquationImageObjectDCDrawerTmp<EquationImageFactory::IMAGE_VARIANT_SIGMA> {};
class VariantThetaGreekCharacterDCDrawer : public EquationImageObjectDCDrawerTmp<EquationImageFactory::IMAGE_VARIANT_THETA>{};

static GreekCharacterCharacterDCDrawer		charDrawer;
static EpsilonGreekCharacterDCDrawer		epsilonDrawer;
static VariantThetaGreekCharacterDCDrawer	varthetaDrawer;
static VariantPiGreekCharacterDCDrawer		varpiDrawer;
static VariantRhoGreekCharacterDCDrawer		varrhoDrawer;
static VariantSigmaGreekCharacterDCDrawer	varsigmaDrawer;
static VariantPhiGreekCharacterDCDrawer		varphiDrawer;

static EquationDrawer *drawers[GreekCharacter::Attribute::ATTRIBUTE_NUM][GREEK_CHARACTER_NUM] =
{
	{
		&charDrawer, &charDrawer, &charDrawer, &charDrawer, &epsilonDrawer, &charDrawer,
		&charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer,
		&charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer,
		&charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer
	},
	{
		&charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer,
		&charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer,
		&charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer,
		&charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer, &charDrawer
	},
	{
		0,		 0,             0,            0,   &charDrawer, 0,
		0, &varthetaDrawer,             0,            0,             0, 0,
		0,               0,             0, &varpiDrawer, &varrhoDrawer, &varsigmaDrawer,
		0,               0, &varphiDrawer,            0,             0, 0
	},
};

static EquationDrawer *getDrawer(Equation *eq)
{
	GreekCharacter *greek = static_cast<GreekCharacter*>(eq);
	EquationDrawer *drawer = drawers[greek->attr()][greek->type()];
	assert(drawer);
	return drawer;
}

void GreekCharacterDCDrawer::draw(Equation *eq, DrawContext *context)
{
	EquationDrawer *drawer = getDrawer(eq);
	drawer->draw(eq, context);
}

void GreekCharacterDCDrawer::size(Equation *eq, DrawContext *context, Equation::Size &sz)
{
	EquationDrawer *drawer = getDrawer(eq);
	drawer->size(eq, context, sz);
}
