/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: HilightSwitch.h,v 1.7 2003/09/12 06:58:23 yoshi Exp $ */ 
#ifndef HilightSwitch_h
#define HilightSwitch_h

#include <windows.h>

#include "EquationColor.h"

class HilightSwitch
{
private:
	enum { COLOR_NOT_SET = 0xffffffff, };
private:
	const EquationColor	&m_color;

	bool	m_on;
	bool	m_link;
	HPEN	m_hilightPen;
	HPEN	m_normalPen;
	HPEN	m_origPen;
	UINT	m_origColor;

private:
	void	init();
	void	free_();


public:
	HilightSwitch(const EquationColor &c) : m_color(c){ init(); }
	virtual ~HilightSwitch() { free_(); }

	UINT			color() const;
	UINT			color(EquationColor::Type t) const;
	EquationColor::Type	colorType() const;
	EquationColor::Type	normalColorType() const;
	EquationColor::Type	hilightColorType() const ;

	void	start(HDC);
	void	end(HDC);

	void	on(HDC);
	void	off(HDC);
	void	on(bool b, HDC hDC)
	{
		if (b) { on(hDC); }
		else { off(hDC); }
	}

	void	link(bool b, HDC hDC) { m_link = b; on(m_on, hDC);}
};
 
#endif  // HilightSwitch_h
