/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: LinkEquationManager.h,v 1.2 2001/11/14 05:58:20 yoshi Exp $ */ 
#ifndef LinkEquationManager_h
#define LinkEquationManager_h

#include "List.h"

class LinkEquation;

class LinkEquationManager
{
private:
	class Rect {
	public:
		int	sx, sy;
		int	ex, ey;
	public:
		Rect(int sx_, int sy_, int ex_, int ey_) : sx(sx_), sy(sy_), ex(ex_), ey(ey_) {;}
		bool in(int x, int y)
		{
			return ((sx <= x && x <= ex) && (sy <= y && y <= ey))? true: false;
		}
	};

	class LinkRect
	{
	public:
		LinkEquation *	link;
		Rect *		rect;
	public:
		LinkRect(LinkEquation *l, Rect *r) : link(l), rect(r) {;}
		virtual ~LinkRect() { if (rect) { delete rect; rect = 0; } }
	};

	typedef LinkRect Element;
	typedef List<Element*> Container;
	typedef ListIterator<Element*> ContainerIterator;

private:
	Container	m_container;

private:
	void	setLinkRect(Element *p) { m_container.pushBack(p); }
	void	free_();

public:
	virtual ~LinkEquationManager() { free_(); }
	void	set(LinkEquation *eq, int sx, int sy, int ex, int ey)
	{
		setLinkRect(new LinkRect(eq, new Rect(sx, sy, ex, ey)));
	}

	char	*link(int x, int y);
	void	clear();
};

#endif  // LinkEquationManager_h
