/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: OperatorConnectionDCDrawer.cpp,v 1.9 2002/09/13 08:11:37 yoshi Exp $ */ 
#include "OperatorConnectionDCDrawer.h"
#include "OperatorConnection.h"
#include "OperatorEquation.h"
#include "DrawContext.h"
#include "EquationSizeManager.h"

DrawContext &childContext(DrawContext &parent, DrawContext &o)
{
	o = parent;
	return o;
}

#define opContext	childContext
#define rightContext	childContext
#define leftContext	childContext

void OperatorConnectionDCDrawer::draw(Equation *eq, DrawContext *context)
{
	Equation::Size *whole_sz = eq->size(context);
	OperatorConnection *con = static_cast<OperatorConnection*>(eq);
	OperatorEquation *op = con->op();

	int cy = context->point.y.center(whole_sz->heightLength());

	// NX𕪂̂͂܂܂...
	if (op->type() == OperatorEquation::COMPARATIVE) { 

		DrawContext op_context;
		opContext(*context, op_context);
		op_context.point.x.setCenter(context->point.x.center(whole_sz->widthLength()));
		op_context.point.y.setCenter(cy);
		op->draw(&op_context);
		Equation::Size *op_sz = op->size(&op_context);

		Equation *left = con->left();
		if (left) { 
			DrawContext left_context;
			leftContext(*context, left_context);
			left_context.point.x.setEnd(op_context.point.x.start(op_sz->widthLength()));
			left_context.point.y.setCenter(cy);
			left->draw(&left_context);
		}

		Equation *right = con->right();
		if (right) { 
			DrawContext right_context;
			rightContext(*context, right_context);
			right_context.point.x.setStart(op_context.point.x.end(op_sz->widthLength()));
			right_context.point.y.setCenter(cy);
			right->draw(&right_context);
		}
	} else {
		int	prev_end_x = context->point.x.start(whole_sz->widthLength());

#define DRAW_CHILD(EQ) \
	if (Equation *e = EQ) { \
		DrawContext c; childContext(*context, c); \
		c.point.x.setStart(prev_end_x); c.point.y.setCenter(cy); \
		e->draw(&c); \
		Equation::Size *sz = e->size(&c); \
		prev_end_x += sz->width();}

		DRAW_CHILD(con->left());
		DRAW_CHILD(con->op());
		DRAW_CHILD(con->right());
	}
}

#define MAX(a, b) (((a)>(b))? (a): (b))

void OperatorConnectionDCDrawer::
size(Equation *eq, DrawContext *context, Equation::Size &eqSz)
{
	OperatorConnection *con = static_cast<OperatorConnection*>(eq);

	Equation::Size *sz;
	int	width = 0;
	int	left_width = 0;
	Length	height;	// Sʒulɓ
	Equation *left = con->left();
	if (left) {
		sz = left->size(context);
		width += sz->width();
		height += sz->heightLength();
		left_width = width;
	}

	OperatorEquation *op = con->op();
	Equation::Size *op_sz = op->size(context);

	width += op_sz->width();
	height += op_sz->heightLength();

	Equation *right = con->right();
	if (right) {
		sz = right->size(context);
		width += sz->width();
		height += sz->heightLength();
	}
	int	cx = (op->type() == OperatorEquation::COMPARATIVE)?
		left_width + op_sz->widthLength().start_center():
		width/2;

	eqSz.set(width, height.value());
	eqSz.setCenter(cx, height.start_center());
}
