/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: OverwriteCharacterEquationDCDrawer.cpp,v 1.1 2004/02/19 08:30:54 yoshi Exp $ */
#include "OverwriteCharacterEquationDCDrawer.h"
#include "ContentEquation.h"
#include "DrawContext.h"
#include "EquationSizeManager.h"
#include "ViewBuffer.h"
#include "CharacterDCDrawer.h"
#include "EquationDCDrawerUtil.h"

static DrawContext &createContext(DrawContext &parent, DrawContext &new_context)
{
	new_context = parent;
	return new_context;
}

static DrawContext &contentContext(DrawContext &parent, DrawContext &new_context)
{
	return createContext(parent, new_context);
}

DrawContext &OverwriteCharacterEquationDCDrawer::overwriteContext(DrawContext &parent, DrawContext &new_context)
{
	return createContext(parent, new_context);
}

//#define DEBUG_DRAW	
#include "EquationDCDrawerUtil.h"

#define UPPER_SHIFTRATE 5
#define RIGHT_SHIFTRAGE 4

void OverwriteCharacterEquationDCDrawer::draw(Equation *eq, DrawContext *context)
{
	DEBUG_DRAW_RECT(eq, context);
	Equation::Size *whole_sz = eq->size(context);
	const int cx = context->point.x.center(whole_sz->width());
	const int sy = context->point.y.end(whole_sz->height());

	ContentEquation *parent = static_cast<ContentEquation*>(eq);
	Equation *content = parent->content();

	DrawContext content_context;
	contentContext(*context, content_context);
	content_context.point.x.setCenter(cx);
	content_context.point.y.setEnd(context->point.y.end(whole_sz->heightLength()));
	DEBUG_DRAW_RECT(content, &content_context);
	content->draw(&content_context);

	DrawContext ow_context;
	overwriteContext(*context, ow_context);
	HDC hDC = ow_context.buffer->getDC();
	HFONT hFont = ow_context.getFont(FontManager::MATH_STRING_NORMAL);
	CharacterDCDrawer cdraw(hDC, hFont);

	RectSize ow_sz;
	char *str = overwriteStr();
	cdraw.size(str, ow_sz);


	Equation::Size *content_sz = content->size(&content_context);
	const int content_sy = content_context.point.y.start(content_sz->heightLength());

	int sx = cx + ow_sz.width()*shiftRightRatio();
	const int ow_height = ow_sz.height();
	int y = content_sy - ow_height*shiftUpRatio();
	cdraw.draw(sx, y, str);
}

void OverwriteCharacterEquationDCDrawer::size(Equation *eq, DrawContext *context, Equation::Size &sz)
{
	ContentEquation *parent = static_cast<ContentEquation*>(eq);
	Equation *content = parent->content();

	DrawContext content_context;
	contentContext(*context, content_context);
	Equation::Size *content_sz = content->size(&content_context);
	int	width = content_sz->width();
	int	height = content_sz->height();

	DrawContext ow_context;
	overwriteContext(*context, ow_context);
	HDC hDC = ow_context.buffer->getDC();
	HFONT hFont = ow_context.getFont(FontManager::MATH_STRING_NORMAL);
	CharacterDCDrawer cdraw(hDC, hFont);
	RectSize ow_sz;
	char *str = overwriteStr();
	cdraw.size(str, ow_sz);

	const int ow_height = ow_sz.height();
	const int up = ow_height*shiftUpRatio();
		
	width += ow_sz.width()/RIGHT_SHIFTRAGE;

	sz.set(width, height);
	sz.setCenter(width/2, content_sz->heightLength().start_center());
}

