/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: OverwriteImageEquationDCDrawer.h,v 1.1 2004/02/19 08:30:55 yoshi Exp $ */ 
#ifndef OverwriteImageEquationDCDrawer_h
#define OverwriteImageEquationDCDrawer_h

#include "EquationDCDrawer.h"

class ImageObject;
class DrawPosition;

class OverwriteImageEquationDCDrawer : public EquationDCDrawer
{
protected:
	virtual ImageObject *image(DrawContext &) = 0;
	virtual bool	stretch() const = 0;
	virtual int	imageTop(DrawPosition &pos, Length &l, int image_height) const = 0;
	virtual int	contentTop(DrawPosition &pos, Length &l, int image_height) const = 0;
	virtual int	centerY(int content_height, int image_height) const = 0;

private:
	void	imageSize(DrawContext &, Equation::Size &, int &w, int &h);
private:
	void	draw(Equation *, DrawContext *);
	void	size(Equation *, DrawContext *, Equation::Size &);
};

class OverwriteImageTopEquationDCDrawer : public OverwriteImageEquationDCDrawer
{
private:
	int	imageTop(DrawPosition &pos, Length &l, int image_height) const;
	int	contentTop(DrawPosition &pos, Length &l, int image_height) const;
	int	centerY(int content_height, int image_height) const;
};

class OverwriteImageBottomEquationDCDrawer : public OverwriteImageEquationDCDrawer
{
private:
	int	imageTop(DrawPosition &pos, Length &l, int image_height) const;
	int	contentTop(DrawPosition &pos, Length &l, int image_height) const;
	int	centerY(int content_height, int image_height) const;
};


#endif // OverwriteImageEquationDCDrawer_h
 
