/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: OverwriteImageEquationDCDrawerImpl.h,v 1.1 2004/02/19 08:30:55 yoshi Exp $ */ 
#ifndef OverwriteImageEquationDCDrawerImpl_h
#define OverwriteImageEquationDCDrawerImpl_h

#include "OverwriteImageEquationDCDrawer.h"
#include "EquationImageFactory.h"
#include "DrawContext.h"

template <class Super, EquationImageFactory::ImageType ITYPE,  bool STRETCH>
class OverwriteImageEquationDCDrawerTmp : public Super
{
private:
	ImageObject *image(DrawContext &c)
	{
		return EquationImageFactory::get(ITYPE, c.hilightSwitch);
	}
	bool stretch() const { return STRETCH; }
};

#undef DECLARE_DRAWER
#define DECLARE_DRAWER(CLASS, POS, ITYPE, STRETCH) \
typedef OverwriteImageEquationDCDrawerTmp<OverwriteImage##POS##EquationDCDrawer, EquationImageFactory::ITYPE, STRETCH> CLASS

DECLARE_DRAWER(WideTildeEquationDCDrawer, Top, IMAGE_WIDE_TILDE, false);
DECLARE_DRAWER(WideHatEquationDCDrawer, Top, IMAGE_WIDE_HAT, false);
DECLARE_DRAWER(BreveEquationDCDrawer, Top, IMAGE_BREVE, false);
DECLARE_DRAWER(CheckEquationDCDrawer, Top, IMAGE_CHECK, false);

DECLARE_DRAWER(OverBraceEquationDCDrawer, Top, IMAGE_OVER_BRACE, true);
DECLARE_DRAWER(UnderBraceEquationDCDrawer, Bottom, IMAGE_UNDER_BRACE, true);
#undef DECLARE_DRAWER


#endif // OverwriteImageEquationDCDrawerImpl_h
 
