/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: OverwriteLineEquationDCDrawer.cpp,v 1.1 2004/02/19 08:30:56 yoshi Exp $ */
#include "OverwriteLineEquationDCDrawer.h"
#include "ContentEquation.h"
#include "DrawContext.h"
#include "ViewBuffer.h"
#include "EquationSizeManager.h"

static DrawContext &contentContext(DrawContext &parent, DrawContext &content)
{
	content = parent;
	return content;
}

//#define HEIGHT_RATIO 0.1

#define LINE(hDC, sx, sy, ex, ey) { ::MoveToEx(hDC, sx, sy, 0); ::LineTo(hDC, ex, ey); }

//#DEBUG_DRAW
#include "EquationDCDrawerUtil.h"

#define MARGIN_SIZE_LEVEL(l) ((l == DRAWLEVEL0)? DRAWLEVEL1: l)

void	OverwriteLineEquationDCDrawer::draw(Equation *eq, DrawContext *context)
{
	DEBUG_DRAW_RECT(eq, context);
	Equation::Size *whole_sz = eq->size(context);
	ContentEquation *bar = static_cast<ContentEquation*>(eq);
	
	Equation *content = bar->content();
	DrawContext content_context;
	contentContext(*context, content_context);
	content->draw(&content_context);
	Equation::Size *content_sz = content->size(&content_context);

	HDC hDC = context->buffer->getDC();
	EquationSizeManager::Size &sz
		= context->sizeMgr->size(MARGIN_SIZE_LEVEL(context->level));
	int	shift = (int)sz.width*rightShiftRatio(); // Eɂ炷
	int	sx = content_context.point.x.start(content_sz->widthLength()) + shift;
	int	ex = content_context.point.x.end(content_sz->widthLength()) + shift;
	//	int	y = content_context.point.y.start(content_sz->heightLength());
	int	y = drawY(content_context.point.y, content_sz->heightLength());

	LINE(hDC, sx, y, ex, y);
}

void	OverwriteLineEquationDCDrawer::size(Equation *eq, DrawContext *context, Equation::Size &eqSz)
{
	ContentEquation *bar = static_cast<ContentEquation*>(eq);
	Equation *content = bar->content();
	DrawContext content_context;
	contentContext(*context, content_context);
	Equation::Size *content_sz = content->size(&content_context);
	int	height = content_sz->height();
	int	width = content_sz->width();

	EquationSizeManager::Size &sz
		= context->sizeMgr->size(MARGIN_SIZE_LEVEL(context->level));
	height += (int)(sz.height*0.1);
	width += sz.width*rightShiftRatio();
	eqSz.set(width, height);
	eqSz.setCenter(content_sz->width()/2, height - content_sz->heightLength().end_center());
}


