/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: PowerEquationDCDrawer.cpp,v 1.9 2003/09/05 04:36:12 yoshi Exp $ */ 
#include "PowerEquationDCDrawer.h"
#include "DrawContext.h"
#include "PowerEquation.h"

DrawContext &powContext(DrawContext &parent, DrawContext &pow)
{
	pow = parent;
	DRAWLEVEL_INCR(pow.level);
	pow.margin = false;
	return pow;
}

DrawContext& baseContext(DrawContext &parent, DrawContext &base)
{
	base = parent;
	return base;
}

#define DEBUG_DRAW
#include "EquationDCDrawerUtil.h"

void	PowerEquationDCDrawer::draw(Equation *eq, DrawContext *context)
{
	DEBUG_DRAW_RECT(eq, context);
	Equation::Size *whole_sz = eq->size(context);

	PowerEquation *seq = static_cast<PowerEquation*>(eq);
	Equation *base = seq->base();
	DrawContext base_context;
	baseContext(*context, base_context);
	base_context.point.x.setStart(context->point.x.start(whole_sz->widthLength()));
	base_context.point.y.setCenter(context->point.y.center(whole_sz->heightLength()));
	base->draw(&base_context);
	Equation::Size *base_sz = base->size(&base_context);

	DrawContext pow_context;
	powContext(*context, pow_context);
	Equation *pow = seq->suffix();
	assert(pow);
	Equation::Size *pow_sz = pow->size(&pow_context);

	const int x = base_context.point.x.innerEnd(base_sz->widthLength());
	pow_context.point.x.setStart(x);
	const int y = base_context.point.y.innerStart(base_sz->heightLength());
	pow_context.point.y.setCenter(y);

	pow->draw(&pow_context);
}

void	PowerEquationDCDrawer::size(Equation *eq, DrawContext *context, Equation::Size &eqSz)
{
	PowerEquation *seq = static_cast<PowerEquation*>(eq);
	Equation *base = seq->base();
	Equation::Size *base_sz = base->size(context);
	int	width = base_sz->width();

	Equation *pow = seq->suffix();
	DrawContext pow_context;
	powContext(*context, pow_context);
	Equation::Size *pow_sz = pow->size(&pow_context);

	const int bp_width = base_sz->widthLength().innerEnd() + pow_sz->width();
	width = (bp_width > width)? bp_width : width;

	const int pow_sc = pow_sz->heightLength().start_center();
	const int height = base_sz->height() - base_sz->heightLength().innerStart() + pow_sc;

	eqSz.set(width, height);
	eqSz.setCenter(base_sz->width()/2,  height - base_sz->heightLength().end_center());
}
