/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: TagEquationManager.h,v 1.3 2001/11/14 05:58:21 yoshi Exp $ */ 
#ifndef TagEquationManager_h
#define TagEquationManager_h

#ifdef WIN32
#pragma warning(disable:4786)
#endif

#include "MultiMap.h"

class Equation;
class DrawContext;
class ViewBuffer;

class TagEquationManager
{
public:
	typedef char	KeyType;
private:
	class EquationCmpnt{
	public:
		Equation *equation;
		DrawContext *context;
	};
		
private:
	typedef MultiMap<KeyType, EquationCmpnt*> EquationMap;
	typedef MultiMapIterator<KeyType, EquationCmpnt*> Iterator;

private:
	EquationMap 	m_map;

private:
	Iterator *	find(KeyType c);
	Iterator *	findAll();

	static void freeIterator(Iterator *&itr) {
		delete itr;
		itr = 0;
	}

	void	free_();

	void		draw(Iterator *, ViewBuffer*);
public:
	virtual ~TagEquationManager() { free_(); }
	void		add(KeyType key, Equation *eq, DrawContext *context);
	void		draw(KeyType key, ViewBuffer *buffer);
	void		draw(ViewBuffer *buffer);
	void		clear();
};
 
#endif  // TagEquationManager_h
