/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: ViewBuffer.h,v 1.2 2001/11/14 05:55:09 yoshi Exp $ */
#ifndef ViewBuffer_h
#define ViewBuffer_h

#ifdef WIN32

#include <windows.h>

class ViewBuffer
{
	friend class ViewBufferDrawUtil;
	friend class ViewBufferReader;
private:
	HDC			m_hDC;
	HBITMAP			m_hBitmap;
	UINT			m_initColor;
	BITMAPINFOHEADER	m_bi;
	
private:
	void		setInitColor(UINT init_color);
	BITMAPINFOHEADER& initBI(int width, int height, BITMAPINFOHEADER &bi);
	HBITMAP		getBitmap() { return m_hBitmap; }
	BITMAPINFO *	getBITMAPINFO();

public:
	ViewBuffer();
	ViewBuffer(HDC hDC, int width, int height,
		   UINT init_color = RGB(255, 255, 255));
	ViewBuffer(ViewBuffer&);

	virtual ~ViewBuffer();

	void		set(HDC hDC, int width, int height,
			    UINT init_color = RGB(255, 255, 255));

	int		width() { return m_bi.biWidth; }
	int		height() { return m_bi.biHeight; }
	int		depth() { return m_bi.biBitCount; }
	HDC		getDC() { return m_hDC; }
	bool		isBackground(UINT c) { return (m_initColor == c)? true: false; }
	void		transparent();
	void		clearBuffer();
};

#endif 	// WIN32
 
#endif  // ViewBuffer_h
